<?php
if(!isset($GLOBALS['sms_dostep_prefix'])) die('Nie zdefiniowano sms_dostep_prefix');
if(!isset($GLOBALS['sms_dostep_klucz'])) die('Nie zdefiniowano sms_dostep_klucz');
if(!isset($GLOBALS['sms_dostep_kodowanie'])) $GLOBALS['sms_dostep_kodowanie'] = 'utf';
if(!isset($GLOBALS['sms_dostep_test'])) $GLOBALS['sms_dostep_test'] = 1;

function sms_dostep($taryfa,$tryb,$czas,$strefa='',$bezokna=false) {
	if(!preg_match('/^([1234569]|19|25)$/', $taryfa)) die('Blad: nieprawidlowa taryfa<br/>');
	if(!preg_match('/^[DHM]$/i', $tryb)) die('Blad: nieprawidlowy tryb (dozwolone: D-dni, H-godziny, M-minuty)<br/>');
	if((int)$czas < 5 || (int)$czas > 180) die('Blad: nieprawidlowy czas (dozwolony zakres 5-180)<br/>');

	$tryb = strtoupper($tryb);
	$sstrefa = sms_dostep_safestr($strefa);
	// sprawdzenie aktualnego kodu
	//
	if(isset($_POST["sms-access-code-$sstrefa"]) && strlen($_POST["sms-access-code-$sstrefa"])) {
		$_COOKIE["sms-access-code-$sstrefa"] = $_POST["sms-access-code-$sstrefa"];
		setcookie("sms-access-code-$sstrefa", $_POST["sms-access-code-$sstrefa"], 0, '/');
		$tmd = array('D'=>86400,'H'=>3600,'M'=>60);
		setcookie("sms-access-code-p-$sstrefa", $_POST["sms-access-code-$sstrefa"], time() + ($czas + 1) * $tmd[$tryb], '/');
		$GLOBALS['sms-access-err'] = 'Kod utracił ważność lub jest nieprawidłowy';
	}
	$err = false;
	if(isset($_COOKIE["sms-access-code-$sstrefa"])) {
		if(sms_dostep_check($_COOKIE["sms-access-code-$sstrefa"],$taryfa,$tryb,$czas,$strefa)) {
			$GLOBALS['sms-access-err'] = null;
			return true; // kod sesyjny prawidlowy
		}
		else {
			setcookie("sms-access-code-$sstrefa", '', 0, '/');
		}
	}
	elseif(isset($_COOKIE["sms-access-code-p-$sstrefa"])) {
		if(sms_dostep_check($_COOKIE["sms-access-code-p-$sstrefa"],$taryfa,$tryb,$czas,$strefa)) {
			$GLOBALS['sms-access-err'] = null;
			return true; // kod cookie prawidlowy
		}
		else {
			setcookie("sms-access-code-p-$sstrefa", '', 0, '/');
			//$GLOBALS['sms-access-err'] = 'Kod utracił ważność lub jest nieprawidłowy';
		}
	}
	if($bezokna) {
		if(!isset($GLOBALS['sms-access-tariff'])) $GLOBALS['sms-access-tariff'] = array();
		$GLOBALS['sms-access-tariff'][] = $taryfa.$tryb.$czas;
	}
	else {
		$GLOBALS['sms-access-tariff'] = array($taryfa.$tryb.$czas);
		sms_dostep_form($strefa);
		exit();
	}
	return false;
}
function sms_dostep_pokaz($strefa='', $tytul='') {
	return sms_dostep_form($strefa, $tytul);
}

function sms_dostep_safestr($s) {
	return preg_replace('/[^a-zA-Z0-9]/','-',$s);
}
function sms_dostep_check($code,$tariff,$mode,$time,$zone) {
	$code = strtoupper(trim($code));
	$code = strtr($code, 'OISG', '0156');
	switch($mode) {
		case 'D': $tmd = 86400; break;
		case 'H': $tmd = 3600; break;
		case 'M': $tmd = 60; break;
	}
	for($n = 0; $n <= $time; $n++) {
		$tv = floor((time() - $n * $tmd) / $tmd);
		$timehash = strtoupper(substr(md5($tv.$tariff.$zone.$GLOBALS['sms_dostep_klucz']),0,4));
		$resphash = strtoupper(substr(md5($mode.$timehash.$GLOBALS['sms_dostep_klucz']),0,6));
		if($code == $resphash) return true;
	}
	return false;
}
function sms_dostep_form($zone, $title) {
	$html = "
<style type='text/css'>
#atomsms { width: 400px; background: #f0f0f0; margin: auto; text-align: left; border: 1px solid silver; padding: 10px 20px; background: white; }
#atomsms * { font-family: verdana,sans-serif; font-size: 12px; color: #444; }
#atomsms h1 { font-family: \"Trebuchet MS\",sans-serif; font-size: 27px; font-weight: normal; color: #47a; margin: 0 0 15px 0; text-align: center; }
#atomsms p { margin: 4px 0 0 0; clear: both; }
#atomsms .premium { border-left: 6px solid #BF1A16; background: #F6F6F6; margin: 5px 0 15px 0; padding: 6px; width: 380px; }
#atomsms p.conn { margin: 20px 0 20px 0; text-align: center; }
#atomsms p.foot { margin-top: 30px; text-align: center; }
#atomsms p.foot img { margin: 5px; }
#atomsms .err { font-weight: bold; color: red; }
</style>
<div id='atomsms'>
<form name='code' action='{$_SERVER['REQUEST_URI']}' method='post'>
<h1>Strefa płatna</h1>
<p>Artykuł <strong>$title</strong> należy do strefy płatnej, do której wejście wymaga wysłania SMSa.</p>";
	foreach($GLOBALS['sms-access-tariff'] as $onetariff) {
		preg_match('/^([0-9]{1,2})(D|H|M)(.*)$/i', $onetariff, $regs);
		list($foo, $tariff, $mode, $time) = $regs;
		$mode = strtoupper($mode);
		switch($mode) {
			case 'D': $tv = floor(time() / 86400); $tn = 'dni'; break;
			case 'H': $tv = floor(time() / 3600); $tn = 'godzin'; break;
			case 'M': $tv = floor(time() / 60); $tn = 'minut'; break;
		}
		$h = md5($GLOBALS['sms_dostep_prefix'].$tariff.$mode.$tv.$zone.$GLOBALS['sms_dostep_test'].$GLOBALS['sms_dostep_klucz']);
		$pars = "p={$GLOBALS['sms_dostep_prefix']}&amp;r={$tariff}&amp;i=msg-{$onetariff}&amp;m={$mode}&amp;t={$tv}&amp;f={$zone}&amp;s={$GLOBALS['sms_dostep_test']}&amp;h=$h&amp;c={$GLOBALS['sms_dostep_kodowanie']}";
		$html .= "\n<p>Dostęp na czas <b>{$time} {$tn}</b>:</p>\n";
		$html .= "<div class='premium'>\n";
		$html .= "<div id='msg-$onetariff'><p class='conn'>Łączenie z serwerem, proszę czekać...</p></div>\n";
		$html .= "<script type='text/javascript' src=\"https://app.atomsms.pl/sms-access.php?$pars\"></script>\n";
		$html .= "</div>\n";
	}
	if(isset($GLOBALS['sms-access-err'])) $html .= "<p class='err'>{$GLOBALS['sms-access-err']}</p>\n";
	$html .= "
<p align='center'>
Tu wpisz kod otrzymany SMSem:<br />
<input type='text' name='sms-access-code-".sms_dostep_safestr($zone)."' />
<button type='submit'>Wejdź</button>
</p>
</form>
<p class='foot'>Płatności SMS obsługuje<br /><a target='_blank' href='https://www.atomsms.pl/' title='Dostęp SMS'><img width='120' height='23' alt='Dostęp SMS' src='https://www.atomsms.pl/img/logo120x23.png' border='0' /></a></p>
</div>
";
	//header('Content-Type: text/html; charset='.sms_dostep_enc());
	return sms_dostep_encode($html);
}
function sms_dostep_enc() {
	switch($GLOBALS['sms_dostep_kodowanie']) {
		case 'iso': return 'iso-8859-2';
		case 'win': return 'windows-1250';
		default: return 'utf-8';
	}
}
function sms_dostep_encode($s) {
	switch($GLOBALS['sms_dostep_kodowanie']) {
		case 'iso':
			$enctab = array(
				'ą'=>'','ć'=>'','ę'=>'','ł'=>'','ń'=>'','ó'=>'','ś'=>'','ż'=>'','ź'=>'',
				'Ą'=>'','Ć'=>'','Ę'=>'','Ł'=>'','Ń'=>'','Ó'=>'','Ś'=>'','Ż'=>'','Ź'=>'');
			return strtr($s, $enctab);
		case 'win':
			$enctab = array(
				'ą'=>'','ć'=>'','ę'=>'','ł'=>'','ń'=>'','ó'=>'','ś'=>'','ż'=>'','ź'=>'',
				'Ą'=>'','Ć'=>'','Ę'=>'','Ł'=>'','Ń'=>'','Ó'=>'','Ś'=>'','Ż'=>'','Ź'=>'');
			return strtr($s, $enctab);
		default:
			return $s;
	}
}
?>